#ifndef TCPSEND_H
#define TCPSEND_H

#define IP_TTL_DEFAULT 64
#define IP_ID_DEFAULT 1
#define TCP_WIN_DEFAULT 1024

/* options, etc. */
extern char *prog;
extern int debug;
extern int suppress_warnings;
extern int quiet;
extern int count;
extern unsigned int pause_time;


extern char *interface_name; 
extern struct ether_addr ether_source_address;
extern struct ether_addr ether_dest_address;
extern struct in_addr ip_src_address;
extern struct in_addr ip_dest_address;
extern unsigned char ip_ttl;
extern unsigned short ip_id;
extern unsigned short ip_frag;
extern int ip_flags;
extern unsigned short tcp_src_port;
extern unsigned short tcp_dest_port;
extern unsigned long tcp_seq_num;
extern unsigned long tcp_ack_num;
extern unsigned short tcp_urg_ptr;
extern unsigned short tcp_win;
extern int tcp_flags;


/* flags indicating the user specified the value */
extern int ether_source_address_set;
extern int ether_dest_address_set;
extern int ip_src_address_set;
extern int ip_dest_address_set;
extern int ip_ttl_set;
extern int ip_id_set;
extern int ip_frag_set;
extern int tcp_src_port_set;
extern int tcp_dest_port_set;
extern int tcp_seq_num_set;
extern int tcp_ack_num_set;
extern int tcp_urg_ptr_set;
extern int tcp_win_set;


extern int sockfd; /* general purpose datagram socket fd for temp use throughout */

/* for libnet */
extern struct libnet_link_int *nd; 

#define MAXLINE 80

/* return true if i is on the loopback network */
#define MY_IN_LOOPBACK(i)  (((i) & 0x7F000000U) == 0x7F000000U)

/* forward decls for functions */
void cleanup(void);
void usage(void);
void fillin_settings(void);
int is_dangerous_settings(void);
int send_packet_prompt(void);
int send_packet(void);


/* If we are positive the prototypes are missing, we declare them.
   We don't really need to declare them (and in fact doing so is bad style),
   but as it's SO easy to mistakenly call these with the wrong type args, I want the extra
   measure of compiler checking provided by declaring these.
*/
#ifndef HAVE_ETHER_NTOA_PROTO
char *ether_ntoa(struct ether_addr *);
#endif
#ifndef HAVE_ETHER_ATON_PROTO
struct ether_addr *ether_aton(char *);
#endif


#endif /* not TCPSEND_H */
